/*
  File autogenerated by gengetopt version 2.10
  generated with the following command:
  gengetopt -i maxent.ggo -u -F maxent_cmdline 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "getopt.h"

#include "maxent_cmdline.h"

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n"
  "Purpose:\n"
  "  A command line utility to train (test) a maxent model from a file.\n"
  "\n"
  "Usage: %s [OPTIONS]... [FILES]...\n", CMDLINE_PARSER_PACKAGE);
  printf("   -h         --help            Print help and exit\n");
  printf("   -V         --version         Print version and exit\n");
  printf("   -v         --verbose         verbose mode (default=off)\n");
  printf("   -mSTRING   --model=STRING    set model filename\n");
  printf("   -b         --binary          save model in binary format (default=off)\n");
  printf("   -oSTRING   --output=STRING   prediction output filename\n");
  printf("              --detail          output full distribution in prediction mode (default=off)\n");
  printf("   -iINT      --iter=INT        iterations for training algorithm (default='30')\n");
  printf("   -gFLOAT    --gaussian=FLOAT  set Gaussian prior, disable if 0 (default='0.0')\n");
  printf("   -cINT      --cutoff=INT      set event cutoff (default='1')\n");
  printf("              --heldout=STRING  specify heldout data for training\n");
  printf("   -r         --random          randomizing data in cross validation (default=off)\n");
  printf("              --nommap          do not use mmap() to read data (slow) (default=off)\n");
  printf("\n");
  printf("   Group: MODE\n");
  printf("   -p         --predict         prediction mode, default is training mode\n");
  printf("   -nINT      --cv=INT          N-fold cross-validation mode (default='0')\n");
  printf("\n");
  printf("   Group: Parameter Estimate Method\n");
  printf("              --lbfgs           use L-BFGS parameter estimation (default)\n");
  printf("              --gis             use GIS parameter estimation\n");
}


static char *gengetopt_strdup (const char *s);

/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;
  int MODE_group_counter = 0;
  
  int Parameter_Estimate_Method_group_counter = 0;
  

  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->verbose_given = 0 ;
  args_info->model_given = 0 ;
  args_info->binary_given = 0 ;
  args_info->output_given = 0 ;
  args_info->detail_given = 0 ;
  args_info->iter_given = 0 ;
  args_info->gaussian_given = 0 ;
  args_info->cutoff_given = 0 ;
  args_info->heldout_given = 0 ;
  args_info->random_given = 0 ;
  args_info->nommap_given = 0 ;
  args_info->predict_given = 0 ;
  args_info->cv_given = 0 ;
  args_info->lbfgs_given = 0 ;
  args_info->gis_given = 0 ;
#define clear_args() { \
  args_info->verbose_flag = 0;\
  args_info->model_arg = NULL; \
  args_info->binary_flag = 0;\
  args_info->output_arg = NULL; \
  args_info->detail_flag = 0;\
  args_info->iter_arg = 30 ;\
  args_info->gaussian_arg = 0.0 ;\
  args_info->cutoff_arg = 1 ;\
  args_info->heldout_arg = NULL; \
  args_info->random_flag = 0;\
  args_info->nommap_flag = 0;\
  args_info->cv_arg = 0 ;\
}

  clear_args();

  args_info->inputs = NULL;
  args_info->inputs_num = 0;

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "verbose",	0, NULL, 'v' },
        { "model",	1, NULL, 'm' },
        { "binary",	0, NULL, 'b' },
        { "output",	1, NULL, 'o' },
        { "detail",	0, NULL, 0 },
        { "iter",	1, NULL, 'i' },
        { "gaussian",	1, NULL, 'g' },
        { "cutoff",	1, NULL, 'c' },
        { "heldout",	1, NULL, 0 },
        { "random",	0, NULL, 'r' },
        { "nommap",	0, NULL, 0 },
        { "predict",	0, NULL, 'p' },
        { "cv",	1, NULL, 'n' },
        { "lbfgs",	0, NULL, 0 },
        { "gis",	0, NULL, 0 },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVvm:bo:i:g:c:rpn:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          clear_args ();
          cmdline_parser_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          clear_args ();
          cmdline_parser_print_version ();
          exit (EXIT_SUCCESS);

        case 'v':	/* verbose mode.  */
          if (args_info->verbose_given)
            {
              fprintf (stderr, "%s: `--verbose' (`-v') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->verbose_given = 1;
          args_info->verbose_flag = !(args_info->verbose_flag);
          break;

        case 'm':	/* set model filename.  */
          if (args_info->model_given)
            {
              fprintf (stderr, "%s: `--model' (`-m') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->model_given = 1;
          args_info->model_arg = gengetopt_strdup (optarg);
          break;

        case 'b':	/* save model in binary format.  */
          if (args_info->binary_given)
            {
              fprintf (stderr, "%s: `--binary' (`-b') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->binary_given = 1;
          args_info->binary_flag = !(args_info->binary_flag);
          break;

        case 'o':	/* prediction output filename.  */
          if (args_info->output_given)
            {
              fprintf (stderr, "%s: `--output' (`-o') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->output_given = 1;
          args_info->output_arg = gengetopt_strdup (optarg);
          break;

        case 'i':	/* iterations for training algorithm.  */
          if (args_info->iter_given)
            {
              fprintf (stderr, "%s: `--iter' (`-i') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->iter_given = 1;
          args_info->iter_arg = strtol (optarg,&stop_char,0);
          break;

        case 'g':	/* set Gaussian prior, disable if 0.  */
          if (args_info->gaussian_given)
            {
              fprintf (stderr, "%s: `--gaussian' (`-g') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->gaussian_given = 1;
          args_info->gaussian_arg = (float)strtod (optarg, NULL);
          break;

        case 'c':	/* set event cutoff.  */
          if (args_info->cutoff_given)
            {
              fprintf (stderr, "%s: `--cutoff' (`-c') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->cutoff_given = 1;
          args_info->cutoff_arg = strtol (optarg,&stop_char,0);
          break;

        case 'r':	/* randomizing data in cross validation.  */
          if (args_info->random_given)
            {
              fprintf (stderr, "%s: `--random' (`-r') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->random_given = 1;
          args_info->random_flag = !(args_info->random_flag);
          break;

        case 'p':	/* prediction mode, default is training mode.  */
          if (args_info->predict_given)
            {
              fprintf (stderr, "%s: `--predict' (`-p') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->predict_given = 1;
          MODE_group_counter += 1;
        break;

        case 'n':	/* N-fold cross-validation mode.  */
          if (args_info->cv_given)
            {
              fprintf (stderr, "%s: `--cv' (`-n') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->cv_given = 1;
          MODE_group_counter += 1;
        args_info->cv_arg = strtol (optarg,&stop_char,0);
          break;


        case 0:	/* Long option with no short option */
          /* output full distribution in prediction mode.  */
          if (strcmp (long_options[option_index].name, "detail") == 0)
          {
            if (args_info->detail_given)
              {
                fprintf (stderr, "%s: `--detail' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->detail_given = 1;
            args_info->detail_flag = !(args_info->detail_flag);
            break;
          }
          
          /* specify heldout data for training.  */
          else if (strcmp (long_options[option_index].name, "heldout") == 0)
          {
            if (args_info->heldout_given)
              {
                fprintf (stderr, "%s: `--heldout' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->heldout_given = 1;
            args_info->heldout_arg = gengetopt_strdup (optarg);
            break;
          }
          
          /* do not use mmap() to read data (slow).  */
          else if (strcmp (long_options[option_index].name, "nommap") == 0)
          {
            if (args_info->nommap_given)
              {
                fprintf (stderr, "%s: `--nommap' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->nommap_given = 1;
            args_info->nommap_flag = !(args_info->nommap_flag);
            break;
          }
          
          /* use L-BFGS parameter estimation (default).  */
          else if (strcmp (long_options[option_index].name, "lbfgs") == 0)
          {
            if (args_info->lbfgs_given)
              {
                fprintf (stderr, "%s: `--lbfgs' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->lbfgs_given = 1; Parameter_Estimate_Method_group_counter += 1;
          
            break;
          }
          
          /* use GIS parameter estimation.  */
          else if (strcmp (long_options[option_index].name, "gis") == 0)
          {
            if (args_info->gis_given)
              {
                fprintf (stderr, "%s: `--gis' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->gis_given = 1; Parameter_Estimate_Method_group_counter += 1;
          
            break;
          }
          

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          exit (EXIT_FAILURE);

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", CMDLINE_PARSER_PACKAGE, c);
          abort ();
        } /* switch */
    } /* while */

  if ( MODE_group_counter > 1)
    {
      fprintf (stderr, "%s: %d options of group MODE were given. At most one is required\n", CMDLINE_PARSER_PACKAGE, MODE_group_counter);
      missing_required_options = 1;
    }
  
  if ( Parameter_Estimate_Method_group_counter > 1)
    {
      fprintf (stderr, "%s: %d options of group Parameter Estimate Method were given. At most one is required\n", CMDLINE_PARSER_PACKAGE, Parameter_Estimate_Method_group_counter);
      missing_required_options = 1;
    }
  

  if ( missing_required_options )
    exit (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;
  
      args_info->inputs_num = argc - optind ;
      args_info->inputs = 
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ; 
    }
  
  return 0;
}
